import quixote.http_request

from http_response import HTTPResponse
from quixote import get_session, get_publisher

class HTTPRequest(quixote.http_request.HTTPRequest):
    def __init__(self, *args, **kwargs):
        quixote.http_request.HTTPRequest.__init__(self, *args, **kwargs)
        self.response = HTTPResponse()

    _user = () # use empty tuple instead of None as None is a "valid" user value
    def get_user(self):
        if self._user != ():
            return self._user
        self._user = get_session().get_user()
        return self._user
    user = property(get_user)

    def get_server(self, clean = True):
        server_name = quixote.http_request.HTTPRequest.get_server(self)
        if clean and server_name.lower()[:7] in ('iframe.', 'iframe-'):
            server_name = server_name[7:]
        return server_name

    def _process_multipart(self, length, params):
        # Make sure request.form doesn't contain unicode strings, converting
        # them all to strings in the site charset; it would contain unicode
        # strings when the user agent specifies a charset in a mime content
        # part, such a behaviour appears with some Nokia phones (6020, 6300)
        quixote.http_request.HTTPRequest._process_multipart(self, length, params)
        site_charset = get_publisher().site_charset
        for k, v in self.form.items():
            if type(v) is unicode:
                self.form[k] = v.encode(site_charset)
