import random
import string

from qommon.storage import StorableObject
import time

class Token(StorableObject):
    _names = 'tokens'

    type = None
    expiration = None

    def __init__(self,
            expiration_delay = 86400,
            size = 16,
            chars = list(string.digits + string.letters)):
        StorableObject.__init__(self, self.get_new_id(size, chars))
        self.expiration = time.time() + expiration_delay

    def get_new_id(cls, size, chars):
        keys = cls.keys()
        while True:
            id = ''.join([random.choice(chars) for x in range(size)])
            if not id in keys:
                return id

    def migrate(self):
        if self.expiration < time.time():
            self.remove_self()
            raise KeyError()
